"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const async_function_1 = require("../../libs/async-function");
const file_remote_1 = require("../../libs/file-remote");
class JsExec {
    script;
    path;
    ignoreVarsBeforeExec = ['script'];
    logger;
    async init(props) {
        if (typeof props === 'string') {
            this.script = props;
        }
        else {
            Object.assign(this, props);
        }
    }
    async exec() {
        try {
            if (this.path) {
                const fileRemote = new file_remote_1.FileRemote(this.path);
                this.script = await fileRemote.getTextContent();
            }
            if (!this.script)
                throw new Error('"script" or "path" is required');
            this.logger.debugBlock(true);
            const rs = await (0, async_function_1.callFunctionScript)(this.script, this, { logger: this.logger });
            return rs;
        }
        finally {
            this.logger.debugBlock(false);
        }
    }
    async dispose() { }
}
exports.default = JsExec;
//# sourceMappingURL=js.js.map